﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ERPProduction.WPF.ServiceReference1;
using ERPProduction.WPF.Interface;
using ERPProduction.WPF.Util;

namespace ERPProduction.WPF.Control
{
    
    /// <summary>
    /// Lógica de interacción para UCConfigEmpresa.xaml
    /// </summary>
    public partial class UCConfigEmpresa : UserControl, ISwitchable
    {
        bool edicio;
        
        /// <summary>
        /// Constructor d'Edicio d'una Empresa
        /// </summary>
        public UCConfigEmpresa(int ID_Empresa)
        {
            InitializeComponent();
            ERPProductionClient servei = new ServiceReference1.ERPProductionClient();
            var empresa = servei.buscarEmpresa(ID_Empresa);
            servei.Close();

            wpnlEmpresa.DataContext = empresa;
            edicio = true;
            
        }
        /// <summary>
        /// Constructor Creacio d'Una Empresa
        /// </summary>
        public UCConfigEmpresa()
        {
            InitializeComponent();
            EmpresaEntity empresa = new EmpresaEntity();
            wpnlEmpresa.DataContext = empresa;            
            
            edicio = false;
            btnEliminar.IsEnabled = false;
            MainWindow.empresa = true;
        }


        #region ISwitchable Members

        void ISwitchable.UtilizeState(object state)
        {
            throw new NotImplementedException();
        }

        #endregion

        /// <summary>
        /// Posicionem Focus al txt NOm
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            txtNom.Focus();
        }

        #region Accions

        /// <summary>
        /// Actualitzar Empresa o Crear Empresa per primer cop
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        private void btnDesar_Click(object sender, RoutedEventArgs e)
        {
            
            var empresa = (EmpresaEntity)wpnlEmpresa.DataContext;

            if (validacioCamps())
            {
                 
                 ERPProductionClient servei = new ServiceReference1.ERPProductionClient();
                 if (edicio)
                 {
                     try
                     {
                         MessageBox.Show("Editem Empresa", "Editar Empresa", MessageBoxButton.OK, MessageBoxImage.Information);
                         servei.updateEmpresa(empresa);
                         MessageBox.Show("Empresa Actualitzada", "Actualitzar Empresa", MessageBoxButton.OK, MessageBoxImage.Information);
                         
                     }
                     catch (Exception)
                     {
                          Alerta.alertaInfo(Textes.EmpresaUpdateNok);
                     }
                 }
                 else
                 { 
                     try
                     {
                         MessageBox.Show("Afegim Empresa", "Afegir Empresa", MessageBoxButton.OK, MessageBoxImage.Information);
                         servei.insertEmpresa(empresa);
                         MessageBox.Show("Empresa Afegida", "Afegir Empresa", MessageBoxButton.OK, MessageBoxImage.Information);
                         MainWindow.empresaID = empresa.ID_Empresa;
                         
                     }                    
                    catch (Exception)
                    {
                        Alerta.alertaInfo(Textes.EmpresaAddNok);
                    }
                }

                servei.Close();             
            }
            else
                {
                Alerta.alertaError(Textes.campsIncor);
                }          
        }
        /// <summary>
        /// Eliminar d'Empresa
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnEliminar_Click(object sender, RoutedEventArgs e)
        {
            Button btn = (Button)sender;
            EmpresaEntity empresa = ((EmpresaEntity)btn.DataContext);
            int id = empresa.ID_Empresa;
            MessageBox.Show("S'eliminarà l'Empresa: " + System.Environment.NewLine + empresa.Nom_Empresa, "Eliminar Empresa", MessageBoxButton.OK, MessageBoxImage.Information);

            try
            {

                ERPProductionClient servei = new ServiceReference1.ERPProductionClient();
                servei.deleteEmpresaByID(id);
                servei.Close();
                
                Alerta.alertaInfo(Textes.EmpresaElimOk);
            }
            catch (Exception)
            {
                Alerta.alertaError1();
                Alerta.alertaInfo(Textes.EmpresaElimNok);
            }
            
        }
       
        #endregion

        /// <summary>
        /// Validem els camps NO NUlls
        /// </summary>
        /// <returns></returns>
        private Boolean validacioCamps()
        {
            Boolean validacio = true;

            ///
            /// Validem camp no Null Nom Empresa
            ///

            if (String.IsNullOrEmpty(txtNom.Text) == true)
            {
                Alerta.alertaInfo(Textes.campNoNull);
                txtNom.Focus();
                return false;
            }
            return validacio;
         }



    }
}
