﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ERPProduction.WPF.ServiceReference1;
using ERPProduction.WPF.Interface;
using ERPProduction.WPF.Util;

namespace ERPProduction.WPF.Control
{
    /// <summary>
    /// Lógica de interacción para UCGestioComponentCon.xaml
    /// </summary>
    public partial class UCGestioComponentCon : UserControl, ISwitchable
    {
    bool edit;
        /// <summary>
        /// Constructor per editar un Component
        /// </summary>
        /// <param name="DNI">ID del component a editar</param>
        public UCGestioComponentCon(int ID_Component)
        {
            
            InitializeComponent();
            combosCompo();

            ERPProductionClient servei = new ServiceReference1.ERPProductionClient();
            var component = servei.buscarComponent(ID_Component);
            servei.Close();

            comboFromComponents(component);
            wpnlComponent.DataContext = component;
            txtbTitol.Text = "Editar Component";
            btnRefrescarComponent.Visibility = Visibility.Collapsed;
            
            edit = true;

        }

        /// <summary>
        /// Constructor d'un nou Component
        /// </summary> 
        public UCGestioComponentCon()
        {
            InitializeComponent();
            combosCompo();
            
            
            ComponentEntity component = new ComponentEntity();
            component.Estat = true;
            component.Data_Alta_Compo =  DateTime.Now;

            wpnlComponent.DataContext = component;
            txtbTitol.Text = "Afegir Component";
            btnRefrescarComponent.Visibility = Visibility.Collapsed;

            edit = false;
        
        }

        #region ISwitchable Members

        void ISwitchable.UtilizeState(object state)
        {
            throw new NotImplementedException();
        }

        #endregion

        /// <summary>
        /// Carreguem els combox de components
        /// </summary>
        private void combosCompo()
        {
            ERPProductionClient servei = new ServiceReference1.ERPProductionClient();
            cboxTipusCompo.DataContext = servei.GetAllTipusCompo();
            cboxEstructura.DataContext = servei.GetAllEstructures();
            servei.Close();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="component"></param>

        private void comboFromComponents(ComponentEntity component)
        {
            ERPProductionClient servei = new ServiceReference1.ERPProductionClient();
            var tipusCompo = servei.buscarComponent(component.ID_Component);
            var estructura = servei.buscarComponent(component.ID_Estructura);
            servei.Close();

            cboxTipusCompo.SelectedValue = ((TipusComponentsEntity[])cboxTipusCompo.DataContext).Single(x => x.ID_Tipus_Compo == component.ID_Tipus_Compo);
            cboxEstructura.SelectedValue = ((EstructuraEntity[])cboxEstructura.DataContext).Single(x => x.ID_Estructura == component.ID_Estructura);
        }


        /// <summary>
        /// 
        /// </summary>
        private void comboToFirstItem()
        {
            cboxEstructura.SelectedValue = ((EstructuraEntity[])cboxEstructura.DataContext).First();
            cboxTipusCompo.SelectedValue = ((TipusComponentsEntity[])cboxTipusCompo.DataContext).First();

        }

        /// <summary>
        /// Validem els camps NO NUlls
        /// </summary>
        /// <returns></returns>
        private Boolean validacioCamps()
        {
            Boolean validacio = true;

            ///
            ///Validem camp no Null Nom
            ///

            if (String.IsNullOrEmpty(txtNom.Text) == true)
            {
                Alerta.alertaInfo(Textes.campNoNull);
                txtNom.Focus();
                return false;
            }

            return validacio;
        }

        #region Accions

        /// <summary>
        /// Desar o Actualitzar una Component
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        private void Desar_Click(object sender, RoutedEventArgs e)
        {
            var component = (ComponentEntity)wpnlComponent.DataContext;

            if (validacioCamps())
            {
               /* component.ID_Estructura = ((EstructuraEntity)cboxEstructura.SelectedValue).ID_Estructura;*/
                component.ID_Tipus_Compo = ((TipusComponentsEntity)cboxTipusCompo.SelectedValue).ID_Tipus_Compo;
                
                ERPProductionClient servei = new ServiceReference1.ERPProductionClient();
                if (edit)
                {
                    try
                    {
                        servei.updateComponent(component);
                       /* Alerta.alertaInfo(Textes.PersonaUpdateOk);*/
                    }
                    catch (Exception)
                    {
                       /* Alerta.alertaInfo(Textes.PersonaUpdateNok);*/
                    }
                }
                else
                {
                    try
                    {
                        servei.insertComponent(component);
                        /*Alerta.alertaInfo(Textes.PersonaAddOk);*/
                    }
                    catch (Exception)
                    {
                        /*Alerta.alertaInfo(Textes.PersonaAddNok);*/
                    }
                }

                servei.Close();
                Switcher.Switch(new UCGestioComponents());
            }
            else
            {
                Alerta.alertaError(Textes.campsIncor);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Refrescar_Click(object sender, RoutedEventArgs e)
        {

        }

        /// <summary>
        /// Sortir de la pantalla de Edicio o creació de components, torna a pantalla principal Gestio de Components
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Sortir_Click(object sender, RoutedEventArgs e)
        {
            Switcher.Switch(new Control.UCGestioComponents());
        }

        #endregion


        private void image1_ImageFailed(object sender, ExceptionRoutedEventArgs e)
        {

        }

        private void Image_ImageFailed(object sender, ExceptionRoutedEventArgs e)
        {

        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            txtNom.Focus();
        }










    }
}
