﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ERPProduction.WPF.ServiceReference1;
using ERPProduction.WPF.Interface;
using ERPProduction.WPF.Util;

namespace ERPProduction.WPF
{
    /// <summary>
    /// Lógica de interacció per MainWindow.xaml
    /// Pantalla principal de l'Aplicació d'Administració
    /// </summary>
    public partial class MainWindow : Window
    {
        DateTime dt = DateTime.Now;
        public static bool empresa;
        public static int empresaID;

        public MainWindow()
        {
            InitializeComponent();
            Switcher.controlSwitcher = this;
            txtDate.Text = dt.ToString("dddd, dd MMMM yyyy");
            txtbUser.Text = Environment.UserName;
        
        }

        public void Navigate(UserControl nextPage)
        {
            contentControl1.Content = nextPage;
            stcPanelBenbinguda.Visibility = Visibility.Collapsed;

        }

        public void Navigate(UserControl nextPage, object state)
        {
            contentControl1.Content = nextPage;
            stcPanelBenbinguda.Visibility = Visibility.Collapsed;
            ISwitchable s = nextPage as ISwitchable;

            if (s != null)
                s.UtilizeState(state);
            else
                throw new ArgumentException("NextPage is not ISwitchable! "
                  + nextPage.Name.ToString());
        }


        #region Click Events

        private void btnSortir_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Shutdown();
        }

        private void btnAdminUser_Click(object sender, RoutedEventArgs e)
        {
            Switcher.Switch(new Control.UCGestioUsuaris());
        }

        private void AdminProd_Click(object sender, RoutedEventArgs e)
        {
            var accio = ((MenuItem)sender).Tag.ToString();
            Switcher.Switch(new Control.UCGestioProductesCon(accio));
            
        }

        private void btnAdminProd_Click(object sender, RoutedEventArgs e)
        {
            Switcher.Switch(new Control.UCGestioProductes());
            
        }

        private void btnAdminEstruc_Click(object sender, RoutedEventArgs e)
        {
            Switcher.Switch(new Control.UCGestioEstructura());
        }

        private void btnAdminCompo_Click(object sender, RoutedEventArgs e)
        {
            Switcher.Switch(new Control.UCGestioComponents());
        }

        private void btnAdminOper_Click(object sender, RoutedEventArgs e)
        {
            Switcher.Switch(new Control.UCGestioOperacions());
        }

        private void btnConfigEmpresa_Click(object sender, RoutedEventArgs e)
        {
           
            ERPProductionClient servei = new ServiceReference1.ERPProductionClient();
            var emp = servei.existeixEmpresa(0);
            servei.Close();

            if (emp)
            {
                Switcher.Switch(new Control.UCConfigEmpresa(empresaID));
            }
            else
            {
                Switcher.Switch(new Control.UCConfigEmpresa());
            }
        }
        

        #endregion

        private void Image_ImageFailed(object sender, ExceptionRoutedEventArgs e)
        {
            MessageBox.Show("Error no s'ha pogut carrega Imatge...");
        }

        private void mimGestioCompo_Click(object sender, RoutedEventArgs e)
        {
            Switcher.Switch(new Control.UCGestioComponents());
        }

   }
}
