﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data;
using System.Data.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using ERPProduction.AccessDB;
using ERPProduction.Negoci;
using ERPProduction.NegociEntitats;


namespace ERPProduction.WCF
{
    public class ERPProduction: IERPProduction
    {
        public string GetData(int value)
        {
            return string.Format("Has entrat : {0}", value);
        }


        #region Perfil
        /// <summary>
        /// Existeix Perfil
        /// </summary>
        /// <param name="ID_Perfil"></param>
        /// <returns></returns>
        public bool existeixPerfil(int ID_Perfil)
        {
            PerfilCN obj = new PerfilCN();
            return obj.existeixPerfil(ID_Perfil);
        }
        /// <summary>
        /// Llista tots els Perfils
        /// </summary>
        /// <returns></returns>
        public List<PerfilEntity> GetAllPerfils()
        {
            PerfilCN obj = new PerfilCN();
            return obj.GetAllPerfils();
        }
        /// <summary>
        /// Llista tots els Perfils segons parametres
        /// </summary>
        /// <param name="tipusConsulta"></param>
        /// <param name="valorBuscat"></param>
        /// <returns></returns>
        public List<PerfilEntity> llistarPerfil(int tipusConsulta, string valorBuscat)
        {
            PerfilCN obj = new PerfilCN();
            return obj.llistarPerfil(tipusConsulta, valorBuscat);
        }
        /// <summary>
        /// Inserta Perfil
        /// </summary>
        /// <param name="perfil"></param>
        public void insertPerfil(PerfilEntity perfil)
        {
            PerfilCN obj = new PerfilCN();
            obj.insertPerfil(perfil);
        }
        /// <summary>
        /// Esborrra Perfil
        /// </summary>
        /// <param name="Id"></param>
        public void deletePerfilById(int Id)
        {
            PerfilCN obj = new PerfilCN();
            obj.deletPerfilByID(Id);
        }
        /// <summary>
        /// Actualitza PErfil
        /// </summary>
        /// <param name="perfil"></param>
        public void updatePerfil(PerfilEntity perfil)
        {
            PerfilCN obj = new PerfilCN();
            obj.updatePerfil(perfil);
        }
        #endregion

        #region Persona
        /// <summary>
        /// Existeix Persona
        /// </summary>
        /// <param name="ID_Persona"></param>
        /// <returns></returns>
        public bool existeixPersona(int ID_Persona)
        {
            PersonaCN obj = new PersonaCN();
            return obj.existeixPersona(ID_Persona);
        }
        /// <summary>
        /// Buscar Persona per DNI
        /// </summary>
        /// <param name="DNI"></param>
        /// <returns></returns>
        public PersonaEntity buscarPersona(string DNI)
        {
            PersonaCN obj = new PersonaCN();
            return obj.buscarPersona(DNI);
        }
        /// <summary>
        /// Buscar Persona per ID
        /// </summary>
        /// <param name="ID_Persona"></param>
        /// <returns></returns>
        public PersonaEntity buscarPersonaId(int ID_Persona)
        {
            PersonaCN obj = new PersonaCN();
            return obj.buscarPersonaId(ID_Persona);
        }
        /// <summary>
        /// Llistar totes les PErsones
        /// </summary>
        /// <returns></returns>
        public List<PersonaEntity> GetAllPersones()
        {
            PersonaCN obj = new PersonaCN();
            return obj.GetAllPersones();
        }
        /// <summary>
        /// Llistar totes les Persones amb els parametres
        /// </summary>
        /// <param name="tipusConsulta"></param>
        /// <param name="valorBuscat"></param>
        /// <returns></returns>
        public List<PersonaEntity> llistarPersona(int tipusConsulta, string valorBuscat)
        {
            PersonaCN obj = new PersonaCN();
            return obj.llistarPersona(tipusConsulta, valorBuscat);
        }
        /// <summary>
        /// Insertar PErsona
        /// </summary>
        /// <param name="persona"></param>
        public void insertPersona(PersonaEntity persona)
        {
            PersonaCN obj = new PersonaCN();
            obj.insertPersona(persona);
        }
        /// <summary>
        /// Esborrar Persona
        /// </summary>
        /// <param name="ID_Persona"></param>
        public void deletePersonaByID(int ID_Persona)
        {
            PersonaCN obj = new PersonaCN();
            obj.deletPersonaByID(ID_Persona);
        }
        /// <summary>
        /// Actualitzar Persona
        /// </summary>
        /// <param name="persona"></param>
        public void updatePersona(PersonaEntity persona)
        {
            PersonaCN obj = new PersonaCN();
            obj.updatePersona(persona);            
        }
        /// <summary>
        /// Actualitzar camp Actiu
        /// </summary>
        /// <param name="ID_Persona"></param>
        /// <param name="actiu"></param>
        /// <returns></returns>
        public bool updateActiu(string DNI, bool actiu)
        {
            PersonaCN obj = new PersonaCN();
            return obj.updateActiu(DNI, actiu);
        }
        /// <summary>
        /// Valida login Persona
        /// </summary>
        /// <param name="DNI"></param>
        /// <param name="contrasenya"></param>
        /// <returns></returns>
        public int validarLoginPersona(string DNI, string contrasenya)
        {
            PersonaCN obj = new PersonaCN();
            return obj.validarLoginPersona(DNI, contrasenya);
        }
        /// <summary>
        /// Canviar contrasenya Persona WEB
        /// </summary>
        /// <param name="ID_Persona"></param>
        /// <param name="telefon"></param>
        /// <param name="email"></param>
        public void canviContrasenyaPersonaWeb(int id_Persona, string contrasenya)
        {
           PersonaCN obj = new PersonaCN();
           obj.canviContrasenyaPersonaWeb(id_Persona, contrasenya); 
        }
        #endregion

        #region Usuari
        /// <summary>
        /// Existeix Usuari
        /// </summary>
        /// <param name="ID_Usuari"></param>
        /// <returns></returns>
        public bool existeixUsuari(int ID_Usuari)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// Llista tots els Usuaris registrats
        /// </summary>
        /// <returns></returns>
        public List<UsuarisEntity> GetAllUsuaris()
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// Llista els tots els Usuaris registrats segons parametres buscats
        /// </summary>
        /// <param name="tipusConsulta"></param>
        /// <param name="valorBuscat"></param>
        /// <returns></returns>
        public List<UsuarisEntity> llistarUsuari(int tipusConsulta, string valorBuscat)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// Buscar un Usuari per ID
        /// </summary>
        /// <param name="ID_Usuari"></param>
        /// <returns></returns>
        public UsuarisEntity buscarUsuari(int ID_Usuari)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// Inserta un Usuari
        /// </summary>
        /// <param name="usuari"></param>
        public void insertUsuari(UsuarisEntity usuari)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// Esborra un Usuari
        /// </summary>
        /// <param name="ID_Usuari"></param>
        public void deleteUsuariById(int ID_Usuari)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// Actualitza un Usuari
        /// </summary>
        /// <param name="usuari"></param>
        public void updateUsuari(UsuarisEntity usuari)
        {
            throw new NotImplementedException();
        }
        
        #endregion

        #region Divisio
        /// <summary>
        /// Existeix Divisio
        /// </summary>
        /// <param name="ID_Divisio"></param>
        /// <returns></returns>
        public bool existeixDivisio(int ID_Divisio)
        {
            DivisioCN obj = new  DivisioCN();
            return obj.existeixDivisio(ID_Divisio);
        }
        /// <summary>
        /// Llista totes les Divisions
        /// </summary>
        /// <returns></returns>
        public List<DivisioEntity> GetAllDivisions()
        {
            DivisioCN obj = new DivisioCN();
            return obj.GetAllDivisions();
        }
        /// <summary>
        /// Buscar Divisio
        /// </summary>
        /// <param name="ID_Divisio"></param>
        /// <returns></returns>
        public DivisioEntity buscarDivisio(int ID_Divisio)
        {
            DivisioCN obj = new DivisioCN();
            return obj.buscarDivisio(ID_Divisio);
        }
        /// <summary>
        /// Insertar Divisio
        /// </summary>
        /// <param name="divisio"></param>
        public void insertDivisio(DivisioEntity divisio)
        {
            DivisioCN obj = new DivisioCN();
            obj.insertDivisio(divisio);
        }
        /// <summary>
        /// Esborrar Divisio
        /// </summary>
        /// <param name="ID_Divisio"></param>
        public void deleteDivisioById(int ID_Divisio)
        {
            DivisioCN obj = new DivisioCN();
            obj.deletDivisioByID(ID_Divisio);
        }
        /// <summary>
        /// Actualitzar Divisio
        /// </summary>
        /// <param name="divisio"></param>
        public void updateDivisio(DivisioEntity divisio)
        {
            DivisioCN obj = new DivisioCN();
            obj.updateDivisio(divisio);
        }
        #endregion

        #region Producte
        /// <summary>
        /// Existeix Producte
        /// </summary>
        /// <param name="ID_Producte"></param>
        /// <returns></returns>
        public bool existeixProducte(int ID_Producte)
        {
            ProducteCN obj = new ProducteCN();
            return obj.existeixProducte(ID_Producte);
        }
        /// <summary>
        /// Llistar tots els Productes
        /// </summary>
        /// <returns></returns>
        public List<ProducteEntity> GetAllProductes()
        {
            ProducteCN obj = new ProducteCN();
            return obj.GetAllProductes();
        }
        /// <summary>
        /// LListar tots els productes segons parametres
        /// </summary>
        /// <param name="tipusConsulta"></param>
        /// <param name="valorBuscat"></param>
        /// <returns></returns>
        public List<ProducteEntity> llistarProducte(int tipusConsulta, string valorBuscat)
        {
            ProducteCN obj = new ProducteCN();
            return obj.llistarProducte(tipusConsulta, valorBuscat);
        }
        /// <summary>
        /// Buscar un Producte per ID
        /// </summary>
        /// <param name="ID_Producte"></param>
        /// <returns></returns>
        public ProducteEntity buscarProducte(int ID_Producte)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// Insertar un Producte
        /// </summary>
        /// <param name="producte"></param>
        public void insertProducte(ProducteEntity producte)
        {
            ProducteCN obj = new ProducteCN();
            obj.insertProducte(producte);

        }
        /// <summary>
        /// Esborrar un Producte
        /// </summary>
        /// <param name="ID_Producte"></param>
        public void deleteProducteById(int ID_Producte)
        {
            ProducteCN obj = new ProducteCN();
            obj.deleteProducteById(ID_Producte);
        }
        /// <summary>
        /// Actualitzar un Producte
        /// </summary>
        /// <param name="producte"></param>
        public void updateProducte(ProducteEntity producte)
        {
            ProducteCN obj = new ProducteCN();
            obj.updateProducte(producte);
        }
        #endregion

        #region Familia
        public bool existeixFamilia(int ID_Familia)
        {
            FamiliaCN obj = new FamiliaCN();
            return obj.existeixFamilia(ID_Familia);
        }

        public List<FamiliaEntity> GetAllFamilies()
        {
            FamiliaCN obj = new FamiliaCN();
            return obj.GetAllFamilies();
        }
        /*
        public List<FamiliaEntity> llistarFamilia(int tipusConsulta, string valorBuscat)
        {
            throw
        }*/

        public FamiliaEntity buscarFamilia(int ID_Familia)
        {
            FamiliaCN obj = new FamiliaCN();
            return obj.buscarFamilia(ID_Familia);
        }



        public void insertFamilia(FamiliaEntity familia)
        {
            FamiliaCN obj = new FamiliaCN();
            obj.insertFamilia(familia);
        }

        public void deleteFamiliaById(int ID_Familia)
        {
            FamiliaCN obj = new FamiliaCN();
            obj.deletFamiliaById(ID_Familia);
        }

        public void updateFamilia(FamiliaEntity familia)
        {
            FamiliaCN obj = new FamiliaCN();
            obj.updateFamilia(familia);
        }
        #endregion

        #region Estructura
        /// <summary>
        /// Existeix Estructura
        /// </summary>
        /// <param name="ID_Estructura"></param>
        /// <returns></returns>
        public bool existeixEstructura(int ID_Estructura)
        {
            EstructuraCN obj = new EstructuraCN();
            return obj.existeixEstructura(ID_Estructura);
        }
        /// <summary>
        /// Llistar totes les Estructures
        /// </summary>
        /// <returns></returns>
        public List<EstructuraEntity> GetAllEstructures()
        {
            EstructuraCN obj = new EstructuraCN();
            return obj.GetAllEstructures();
        }
        /// <summary>
        /// Llistar totes les Estructures segons parametres
        /// </summary>
        /// <param name="tipusConsulta"></param>
        /// <param name="valorBuscat"></param>
        /// <returns></returns>
        public List<EstructuraEntity> llistarEstructura(int tipusConsulta, string valorBuscat)
        {
            EstructuraCN obj = new EstructuraCN();
            return obj.llistarEstructura(tipusConsulta, valorBuscat);
        }

        /// <summary>
        /// Podem buscar una Estructura per algun del seus camps TO DO...
        /// </summary>
        /// <param name="ID_Estructura"></param>
        /// <returns></returns>
        public EstructuraEntity buscarEstructura(int ID_Estructura)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// Afegir Estructura
        /// </summary>
        /// <param name="estructura"></param>
        public void insertEstructura(EstructuraEntity estructura)
        {
            EstructuraCN obj = new EstructuraCN();
            obj.insertEstructura(estructura);
        }
        /// <summary>
        /// Esborrar Estructura
        /// </summary>
        /// <param name="ID_Estructura"></param>
        public void deleteEstructuraById(int ID_Estructura)
        {
            EstructuraCN obj = new EstructuraCN();
            obj.deleteEstructuraById(ID_Estructura);
        }
        /// <summary>
        /// Actualitzar Estructura
        /// </summary>
        /// <param name="estructura"></param>
        public void updateEstructura(EstructuraEntity estructura)
        {
            EstructuraCN obj = new EstructuraCN();
            obj.updateEstructura(estructura);
        }
        #endregion

        #region Component
        /// <summary>
        /// Existeix Component
        /// </summary>
        /// <param name="ID_Component"></param>
        /// <returns></returns>
        public bool existeixComponent(int ID_Component)
        {
            ComponentCN obj = new ComponentCN();
            return obj.existeixComponent(ID_Component);
        }
        /// <summary>
        /// Llistar tots els Components
        /// </summary>
        /// <returns></returns>
        public List<ComponentEntity> GetAllComponents()
        {
            ComponentCN obj = new ComponentCN();
            return obj.GetAllComponents();
        }
        /// <summary>
        /// Llistar tots els components segons parametres
        /// </summary>
        /// <param name="tipusConsulta"></param>
        /// <param name="valorBuscat"></param>
        /// <returns></returns>
        public List<ComponentEntity> llistarComponent(int tipusConsulta, string valorBuscat)
        {
            ComponentCN obj = new ComponentCN();
            return obj.llistarComponent(tipusConsulta, valorBuscat);
        }

        /// <summary>
        /// Podem buscar un component per algun del seus camps TO DO...
        /// </summary>
        /// <param name="ID_Component"></param>
        /// <returns></returns>
        public ComponentEntity buscarComponent(int ID_Component)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Inserta un Component
        /// </summary>
        /// <param name="component"></param>
        public void insertComponent(ComponentEntity component)
        {
            ComponentCN obj = new ComponentCN();
            obj.insertComponent(component);
        }

        /// <summary>
        /// Esborra un Component
        /// </summary>
        /// <param name="ID_Component"></param>
        public void deleteComponentById(int ID_Component)
        {
            ComponentCN obj = new ComponentCN();
            obj.deleteComponentById(ID_Component);
        }

        /// <summary>
        /// Actualitza un Component
        /// </summary>
        /// <param name="component"></param>
        public void updateComponent(ComponentEntity component)
        {
            ComponentCN obj = new ComponentCN();
            obj.updateComponent(component);
        }
        #endregion

        #region Foto

        #endregion

        #region Empresa

        /// <summary>
        /// Existeix Empresa
        /// </summary>
        /// <param name="ID_Empresa"></param>
        /// <returns></returns>
        public bool existeixEmpresa(int ID_Empresa)
        {
            EmpresaCN obj = new EmpresaCN();
            return obj.existeixEmpresa(ID_Empresa);
        }
        /// <summary>
        /// Buscar Empresa per Nom
        /// </summary>
        /// <param name="Nom_Empresa"></param>
        /// <returns></returns>
        public EmpresaEntity buscarEmpresa(int ID_Empresa)
        {
            EmpresaCN obj = new EmpresaCN();
            return obj.buscarEmpresa(ID_Empresa);
        }
        /// <summary>
        /// Inserta Empresa
        /// </summary>
        /// <param name="empresa"></param>
        public void insertEmpresa(EmpresaEntity empresa)
        {
            EmpresaCN obj = new EmpresaCN();
            obj.insertEmpresa(empresa);
        }

        /// <summary>
        /// Actualitza Empresa
        /// </summary>
        /// <param name="empresa"></param>
        public void updateEmpresa(EmpresaEntity empresa)
        {
            EmpresaCN obj = new EmpresaCN();
            obj.updateEmpresa(empresa);
        }
        /// <summary>
        /// Esborrar Empresa
        /// </summary>
        /// <param name="ID_Empresa"></param>
        public void deleteEmpresaByID(int ID_Empresa)
        {
            EmpresaCN obj = new EmpresaCN();
            obj.deleteEmpresaById(ID_Empresa);
        }
        #endregion

        #region Operacio
        /// <summary>
        /// Busquem si existeix Operacio
        /// </summary>
        /// <param name="ID_Operacio"></param>
        /// <returns></returns>
        public bool existeixOperacio(int ID_Operacio)
        {
            OperacioCN obj = new OperacioCN();
            return obj.existeixOperacio(ID_Operacio);
        }

        /// <summary>
        /// Llistem totes les Operacions
        /// </summary>
        /// <returns></returns>
        public List<OperacioEntity> GetAllOperacions()
        {
            OperacioCN obj = new OperacioCN();
            return obj.GetAllOperacions();
        }

        /// <summary>
        /// Llistem les Operacions segons tipus de consulta
        /// </summary>
        /// <param name="tipusConsulta"></param>
        /// <param name="valorBuscat"></param>
        /// <returns></returns>
        public List<OperacioEntity> llistarOperacio(int tipusConsulta, string valorBuscat)
        {
            OperacioCN obj = new OperacioCN();
            return obj.llistarOperacio(tipusConsulta, valorBuscat);
        }

        /// <summary>
        /// Podem buscar una operacio per algun del seus camps
        /// </summary>
        /// <param name="ID_Operacio"></param>
        /// <returns></returns>
        public OperacioEntity buscarOperacio(int ID_Operacio)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Insertem Operacio
        /// </summary>
        /// <param name="operacio"></param>
        public void insertOperacio(OperacioEntity operacio)
        {
            OperacioCN obj = new OperacioCN();
            obj.insertOperacio(operacio);
        }

        /// <summary>
        /// Borrem Operacio per ID
        /// </summary>
        /// <param name="ID_Operacio"></param>
        public void deleteOperacioById(int ID_Operacio)
        {
            OperacioCN obj = new OperacioCN();
            obj.deleteOperacioById(ID_Operacio);
        }

        /// <summary>
        /// Actualitzem Operacio
        /// </summary>
        /// <param name="operacio"></param>
        public void updateOperacio(OperacioEntity operacio)
        {
            OperacioCN obj = new OperacioCN();
            obj.updateOperacio(operacio);
        }

        #endregion

        #region TipusComponent
        /// <summary>
        /// Existeix Tipus de Component
        /// </summary>
        /// <param name="ID_Tipus_Compo"></param>
        /// <returns></returns>
        public bool existeixTipusCompo(int ID_Tipus_Compo)
        {
            TipusComponentsCN obj = new TipusComponentsCN();
            return obj.existeixTipusCompo(ID_Tipus_Compo);
        }
        /// <summary>
        /// Obte tots els Tipus de component
        /// </summary>
        /// <returns></returns>
        public List<TipusComponentsEntity> GetAllTipusCompo()
        {
            TipusComponentsCN obj = new TipusComponentsCN();
            return obj.GetAllTipusCompo();
        }
        /// <summary>
        /// Inserta Tipus Component
        /// </summary>
        /// <param name="tipusCompo"></param>
        public void insertTipusCompo(TipusComponentsEntity tipusCompo)
        {
            TipusComponentsCN obj = new TipusComponentsCN();
            obj.insertTipusCompo(tipusCompo);
        }
        /// <summary>
        /// Esborra Tipus de Component
        /// </summary>
        /// <param name="ID_Tipus_Compo"></param>
        public void deleteTipusCompoById(int ID_Tipus_Compo)
        {
            TipusComponentsCN obj = new TipusComponentsCN();
            obj.deleteTipusCompoById(ID_Tipus_Compo);
        }
        /// <summary>
        /// Actualitza Tipus de Component
        /// </summary>
        /// <param name="tipusCompo"></param>
        public void updateTipusCompo(TipusComponentsEntity tipusCompo)
        {
            TipusComponentsCN obj = new TipusComponentsCN();
            obj.updateTipusCompo(tipusCompo);
        }

        #endregion

    }
}
